/*

  File: fm.h -- header file for software emuration for FM sound generator

   Copyright(c) 1998 Tatsuyuki Satoh

*/
#ifndef _H_FM_FM_
#define _H_FM_FM_

typedef unsigned char FM_SAMPLE;

#define YM2203_NUMBUF 1
#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif

/*
** Initialize YM2203 emulator(s).
**
** 'num'     is the number of virtual YM2203's to allocate
** 'rate'    is sampling rate
** 'bufsize' is the buffer size in samples
*/
int OPNInit(int num, int clock, int rate, int bufsiz);

/*
** shutdown the YM2203 emulators .. make sure that no sound system stuff
** is touching our audio buffers ...
*/
void OPNShutdown(void);

/*
** reset all chip registers for YM2203 number 'num'
*/
void OPNResetChip(int num);

/*
*/
void OPNUpdate(void);

void OPNUpdateOne(int chip, int endp);

/*
** write 'v' to register 'r' on YM2203 chip number 'n'
*/
void OPNWriteReg(int n, int r, int v);

/*
** read status  YM2203 chip number 'n'
*/
unsigned char OPNReadStatus(int n);

/* ----- get pointer sound buffer ----- */
FM_SAMPLE *OPNBuffer(int n);
/* ----- set sound buffer ----- */
int OPNSetBuffer(int n, FM_SAMPLE *buf );
/* ---- set user interrupt handler ----- */
void OPNSetIrqHandler(int n, void (*handler)(void) );

#endif /* _H_FM_FM_ */
