#include <stdlib.h>
#include <string.h>
#include "emu.h"
#include "utils.h"

WINDOW *palview_window=NULL;

GADGET gui_palview_dialog[] = {
   /* (dialog proc)       (x)              (y)         (w)           (h)          (flags)  (d1) (d2)    (dp) [dp2] */
   { gui_window_proc,     0,               0,          NC_W+16*8,    NC_H+32*8,   0,       0,   0,      "Palette viewer" },
   { gui_closebox_proc,   16*8+NC_W-12,    2,          9,            9,           D_EXIT,  0,   0,      NULL },
   { gui_palview_proc,    NC_X,            NC_Y,       16*8,         32*8,        0,       0,   0,      NULL },
   { NULL }
};

int gui_palview_proc(MSG *msg, WINDOW *window, GADGET *d)
{
   int n, x, y;
   switch(msg->type)
   {
   case MSG_DRAW:
      if (!current_game)
      {
         clear_to_color(d->bmp, GUI_BG_NORMAL);
         return D_O_K;
      }

      n = 0;
      for (y=0;y<32;y++)
      {
         for (x=0;x<16;x++,n++)
         {
            rectfill(d->bmp, x*8, y*8, x*8+7, y*8+7, palette_map[n]);                     
         }
      }
      return D_O_K;
   }
   return D_O_K;
}

int PalView_Init(WINDOW *window)
{
   int x,y;

   if (palview_window)
   {
      GUI_SwitchFocus(palview_window);
      return D_O_K;
   }

   /* create the palette-viewer window */
   GUI_PrintLog(FALSE, "Creating palette-viewer window...");
   x = get_config_int("Palette_viewer", "x_position", 479);
   y = get_config_int("Palette_viewer", "y_position", 192);
   palview_window = GUI_NewWindow(x, y, gui_palview_dialog, &PalView_Shutdown);

   return D_O_K;
}

void PalView_Update(void)
{
   gui_palview_dialog[2].flags |= D_DIRTY;
}

void PalView_Shutdown(WINDOW *window)
{
   GUI_PrintLog(FALSE, "Shutting down palette-viewer window.");
   set_config_int("Palette_viewer", "x_position", window->x);
   set_config_int("Palette_viewer", "y_position", window->y);
   palview_window = NULL;
}
