#include <string.h>
#include "nz.h"
#include "utils.h"

WINDOW *options_window=NULL, *debug_window=NULL;
char frameskip_value[2];

char frameskip_filter(char key)
{
   if (key >= '1' && key <= ('0'+MAX_FRAME_SKIP)) return key;
   return NULL;
}

char *KeyName(char c) /* 'borrowed' from Raine =) */
{
   switch(c){
   default                    : return "<None>"; // ???
   case KEY_A                 : return "A"; // #1
   case KEY_B                 : return "B"; // #2
   case KEY_C                 : return "C"; // #3
   case KEY_D                 : return "D"; // #4
   case KEY_E                 : return "E"; // #5
   case KEY_F                 : return "F"; // #6
   case KEY_G                 : return "G"; // #7
   case KEY_H                 : return "H"; // #8
   case KEY_I                 : return "I"; // #9
   case KEY_J                 : return "J"; // #10
   case KEY_K                 : return "K"; // #11
   case KEY_L                 : return "L"; // #12
   case KEY_M                 : return "M"; // #13
   case KEY_N                 : return "N"; // #14
   case KEY_O                 : return "O"; // #15
   case KEY_P                 : return "P"; // #16
   case KEY_Q                 : return "Q"; // #17
   case KEY_R                 : return "R"; // #18
   case KEY_S                 : return "S"; // #19
   case KEY_T                 : return "T"; // #20
   case KEY_U                 : return "U"; // #21
   case KEY_V                 : return "V"; // #22
   case KEY_W                 : return "W"; // #23
   case KEY_X                 : return "X"; // #24
   case KEY_Y                 : return "Y"; // #25
   case KEY_Z                 : return "Z"; // #26
   case KEY_0                 : return "0"; // #27
   case KEY_1                 : return "1"; // #28
   case KEY_2                 : return "2"; // #29
   case KEY_3                 : return "3"; // #30
   case KEY_4                 : return "4"; // #31
   case KEY_5                 : return "5"; // #32
   case KEY_6                 : return "6"; // #33
   case KEY_7                 : return "7"; // #34
   case KEY_8                 : return "8"; // #35
   case KEY_9                 : return "9"; // #36
   case KEY_0_PAD             : return "0 (pad)"; // #37
   case KEY_1_PAD             : return "1 (pad)"; // #38
   case KEY_2_PAD             : return "2 (pad)"; // #39
   case KEY_3_PAD             : return "3 (pad)"; // #40
   case KEY_4_PAD             : return "4 (pad)"; // #41
   case KEY_5_PAD             : return "5 (pad)"; // #42
   case KEY_6_PAD             : return "6 (pad)"; // #43
   case KEY_7_PAD             : return "7 (pad)"; // #44
   case KEY_8_PAD             : return "8 (pad)"; // #45
   case KEY_9_PAD             : return "9 (pad)"; // #46
   case KEY_F1                : return "F1"; // #47
   case KEY_F2                : return "F2"; // #48
   case KEY_F3                : return "F3"; // #49
   case KEY_F4                : return "F4"; // #50
   case KEY_F5                : return "F5"; // #51
   case KEY_F6                : return "F6"; // #52
   case KEY_F7                : return "F7"; // #53
   case KEY_F8                : return "F8"; // #54
   case KEY_F9                : return "F9"; // #55
   case KEY_F10               : return "F10"; // #56
   case KEY_F11               : return "F11"; // #57
   case KEY_F12               : return "F12"; // #58
   case KEY_ESC               : return "Esc"; // #59
   case KEY_TILDE             : return ""; // #60
   case KEY_MINUS             : return "-"; // #61
   case KEY_EQUALS            : return "="; // #62
   case KEY_BACKSPACE         : return "Backspace"; // #63
   case KEY_TAB               : return "Tab"; // #64
   case KEY_OPENBRACE         : return "{"; // #65
   case KEY_CLOSEBRACE        : return "}"; // #66
   case KEY_ENTER             : return "Enter"; // #67
   case KEY_COLON             : return ":"; // #68
   case KEY_QUOTE             : return "'"; // #69
   case KEY_BACKSLASH         : return "#"; // #70
   case KEY_BACKSLASH2        : return "\\"; // #71
   case KEY_COMMA             : return ","; // #72
   case KEY_STOP              : return "."; // #73
   case KEY_SLASH             : return "/"; // #74
   case KEY_SPACE             : return "Space"; // #75
   case KEY_INSERT            : return "Insert"; // #76
   case KEY_DEL               : return "Delete"; // #77
   case KEY_HOME              : return "Home"; // #78
   case KEY_END               : return "End"; // #79
   case KEY_PGUP              : return "Page Up"; // #80
   case KEY_PGDN              : return "Page Down"; // #81
   case KEY_LEFT              : return "Left"; // #82
   case KEY_RIGHT             : return "Right"; // #83
   case KEY_UP                : return "Up"; // #84
   case KEY_DOWN              : return "Down"; // #85
   case KEY_SLASH_PAD         : return "/ (pad)"; // #86
   case KEY_ASTERISK          : return "* (pad)"; // #87
   case KEY_MINUS_PAD         : return "- (pad)"; // #88
   case KEY_PLUS_PAD          : return "+ (pad)"; // #89
   case KEY_DEL_PAD           : return "Del (pad)"; // #90
   case KEY_ENTER_PAD         : return "Enter (pad)"; // #91
   case KEY_PRTSCR            : return "Print Scr"; // #92
   case KEY_PAUSE             : return "Pause"; // #93
   case KEY_LSHIFT            : return "Left Shift"; // #94
   case KEY_RSHIFT            : return "Right Shift"; // #95
   case KEY_LCONTROL          : return "Left Ctrl"; // #96
   case KEY_RCONTROL          : return "Right Ctrl"; // #97
   case KEY_ALT               : return "Left Alt"; // #98
   case KEY_ALTGR             : return "Right Alt"; // #99
   case KEY_LWIN              : return "Left Win"; // #100
   case KEY_RWIN              : return "Right Win"; // #101
   case KEY_MENU              : return "Menu Win"; // #102
   case KEY_SCRLOCK           : return "Scr Lock"; // #103
   case KEY_NUMLOCK           : return "Num Lock"; // #104
   case KEY_CAPSLOCK          : return "Caps Lock"; // #105
   }
}

int gui_keysetting_proc(MSG *msg, WINDOW *window, GADGET *d)
{
   int *t, n, quit;
   t = (int *)(d->dp2);
   switch(msg->type)
   {
   case MSG_WANTFOCUS: return D_WANTFOCUS;
   case MSG_CLICK:
      d->flags |= D_SELECTED|D_DIRTY;
      return D_O_K;
   case MSG_IDLE:
      if ((d->flags & D_DIRTY) || !(d->flags & D_SELECTED)) return D_O_K;

      /* cause button to be lit immediately */
      GUI_Refresh(window);

      clear_keybuf();
      quit = FALSE;
      while(!quit)
      {
         for (n=1;n<KEY_MAX;n++)
         {
            if (key[n])
            {
               quit = TRUE;
               break;
            }
         }
      }
      while(key[n]);
      clear_keybuf();

      d->flags &= ~D_SELECTED;
      d->flags |= D_DIRTY;
      if (n != KEY_ESC) *t = n;
      return D_O_K;
   case MSG_DRAW:
      text_mode(GUI_BG_NORMAL);
      gui_textout(d->bmp, d->dp, 2, 2, GUI_BLACK, FALSE);
      if (d->flags & D_SELECTED && window == active_window)
      {
         text_mode(GUI_FG_NORMAL);
         GUI_DrawRect3D(TRUE, d->bmp, d->w - 1, d->h - 1, d->w - 60, 0);
         rectfill(d->bmp, d->w - 59, 1, d->w - 2, d->h - 2, GUI_FG_NORMAL);
      } else {
         text_mode(GUI_BG_NORMAL);
         GUI_DrawRect3D(FALSE, d->bmp, d->w - 1, d->h - 1, d->w - 60, 0);
         rectfill(d->bmp, d->w - 59, 1, d->w - 2, d->h - 2, GUI_BG_NORMAL);
      }
      gui_textout(d->bmp, KeyName(*t), d->w - 58, 1, GUI_BLACK, FALSE);
      return D_O_K;
   }
   return D_O_K;
}

GADGET gui_options_dialog[] = {
   /* (dialog proc)       (x)          (y)      (w)       (h)       (flags)  (d1) (d2)  (dp) */
   { gui_window_proc,     0,           0,       NC_W+367, NC_H+263, 0,       0,   0,    "Options" },
   { gui_closebox_proc,   NC_W+367-12, 2,       9,        9,        D_EXIT,  0,   0,    NULL },

   /* no. 2 - Frameskip */
   { gui_frame_proc,      NC_X+5,     NC_Y+5,   95,       48,       0,       0,   0,    "Frame-skip:" },
   { gui_radio_proc,      NC_X+10,    NC_Y+19,  60,       16,       0,       1,   0,    "Automatic", &Options_UpdateSettings },
   { gui_radio_proc,      NC_X+10,    NC_Y+35,  50,       16,       0,       1,   0,    "Manual", &Options_UpdateSettings },
   { gui_editbox_proc,    NC_X+70,    NC_Y+33,  20,       16,       0,       1,   0,    &frameskip_value, &frameskip_filter, &Options_UpdateSettings },

   /* no. 6 - Vsync */
   { gui_frame_proc,      NC_X+5,     NC_Y+56,  95,       49,       0,       0,   0,    "V-sync:" },
   { gui_radio_proc,      NC_X+10,    NC_Y+70,  85,       16,       0,       2,   0,    "Yes (smoother)", &Options_UpdateSettings },
   { gui_radio_proc,      NC_X+10,    NC_Y+86,  85,       16,       0,       2,   0,    "No (faster)", &Options_UpdateSettings },

   /* no. 9 - Sample rate */
   { gui_frame_proc,      NC_X+5,     NC_Y+108, 95,       66,       0,       0,   0,    "Audio rate:" },
   { gui_radio_proc,      NC_X+10,    NC_Y+122, 85,       16,       0,       3,   0,    "11 KHz, low", &Options_UpdateSettings },
   { gui_radio_proc,      NC_X+10,    NC_Y+138, 85,       16,       0,       3,   0,    "22 KHz, normal", &Options_UpdateSettings },
   { gui_radio_proc,      NC_X+10,    NC_Y+154, 85,       16,       0,       3,   0,    "44 KHz, high", &Options_UpdateSettings },

   /* no. 13 - Keyboard */
   { gui_frame_proc,      NC_X+105,   NC_Y+5,   95,       220,      0,       0,   0,    "Keyboard:" },
   { gui_radio_proc,      NC_X+110,   NC_Y+19,  85,       16,       0,       4,   0,    "USA", &Options_UpdateSettings },
   { gui_radio_proc,      NC_X+110,   NC_Y+35,  85,       16,       0,       4,   0,    "United Kingdom", &Options_UpdateSettings },
   { gui_radio_proc,      NC_X+110,   NC_Y+51,  85,       16,       0,       4,   0,    "Belgium", &Options_UpdateSettings },
   { gui_radio_proc,      NC_X+110,   NC_Y+67,  85,       16,       0,       4,   0,    "Denmark", &Options_UpdateSettings },
   { gui_radio_proc,      NC_X+110,   NC_Y+83,  85,       16,       0,       4,   0,    "Dvorak", &Options_UpdateSettings },
   { gui_radio_proc,      NC_X+110,   NC_Y+99,  85,       16,       0,       4,   0,    "Finland", &Options_UpdateSettings },
   { gui_radio_proc,      NC_X+110,   NC_Y+115, 85,       16,       0,       4,   0,    "France", &Options_UpdateSettings },
   { gui_radio_proc,      NC_X+110,   NC_Y+131, 85,       16,       0,       4,   0,    "Germany", &Options_UpdateSettings },
   { gui_radio_proc,      NC_X+110,   NC_Y+147, 85,       16,       0,       4,   0,    "Italy", &Options_UpdateSettings },
   { gui_radio_proc,      NC_X+110,   NC_Y+163, 85,       16,       0,       4,   0,    "Norway", &Options_UpdateSettings },
   { gui_radio_proc,      NC_X+110,   NC_Y+179, 85,       16,       0,       4,   0,    "Portugal", &Options_UpdateSettings },
   { gui_radio_proc,      NC_X+110,   NC_Y+193, 85,       16,       0,       4,   0,    "Spain", &Options_UpdateSettings },
   { gui_radio_proc,      NC_X+110,   NC_Y+207, 85,       16,       0,       4,   0,    "Sweden", &Options_UpdateSettings },

   /* no. 27 - Controls */
   { gui_frame_proc,      NC_X+210,   NC_Y+5,   152,      220,      0,       0,   0,    "Key settings:" },
   { gui_keysetting_proc, NC_X+215,   NC_Y+25,  140,      16,       0,       0,   0,    "Left:",  &key_left },
   { gui_keysetting_proc, NC_X+215,   NC_Y+45,  140,      16,       0,       0,   0,    "Right:",  &key_right },
   { gui_keysetting_proc, NC_X+215,   NC_Y+65,  140,      16,       0,       0,   0,    "Up:",  &key_up },
   { gui_keysetting_proc, NC_X+215,   NC_Y+85,  140,      16,       0,       0,   0,    "Down:",  &key_down },
   { gui_keysetting_proc, NC_X+215,   NC_Y+105, 140,      16,       0,       0,   0,    "Button 1:",  &key_b1 },
   { gui_keysetting_proc, NC_X+215,   NC_Y+125, 140,      16,       0,       0,   0,    "Button 2:",  &key_b2 },
   { gui_keysetting_proc, NC_X+215,   NC_Y+145, 140,      16,       0,       0,   0,    "Player 1 start:",  &key_start1 },
   { gui_keysetting_proc, NC_X+215,   NC_Y+165, 140,      16,       0,       0,   0,    "Player 2 start:",  &key_start2 },
   { gui_keysetting_proc, NC_X+215,   NC_Y+185, 140,      16,       0,       0,   0,    "Insert coin:",  &key_coin },

   /* no. 37 - Scanlines */
   { gui_frame_proc,      NC_X+5,     NC_Y+175, 95,       50,       0,       0,   0,    "Scanlines:" },
   { gui_radio_proc,      NC_X+10,    NC_Y+189, 85,       16,       0,       5,   0,    "Yes", &Options_UpdateSettings },
   { gui_radio_proc,      NC_X+10,    NC_Y+205, 85,       16,       0,       5,   0,    "No", &Options_UpdateSettings },

   /* OK button */
   { gui_text_proc,       NC_X+5,     NC_Y+227, 240,      16,       0,       0,   0,    "NOTE: You will have to quit and restart" },
   { gui_text_proc,       NC_X+45,    NC_Y+243, 240,      16,       0,       0,   0,    "for audio settings to take effect." },
   { gui_button_proc,     NC_X+291,   NC_Y+238, 70,       20,       D_EXIT,  0,   0,    "OK", NULL },
   { NULL }
};

GADGET gui_debugging_dialog[] = {
   /* (dialog proc)       (x)          (y)       (w)       (h)       (flags)  (d1) (d2)  (dp) */
   { gui_window_proc,     0,           0,        NC_W+240, NC_H+80,  0,       0,   0,    "Debugging options" },
   { gui_closebox_proc,   NC_W+240-12, 2,        9,        9,        D_EXIT,  0,   0,    NULL },

   /* no. 2 - Write log */
   { gui_frame_proc,      NC_X+5,      NC_Y+5,   95,       48,       0,       0,   0,    "Write a log file:" },
   { gui_radio_proc,      NC_X+10,     NC_Y+19,  85,       16,       0,       1,   0,    "Yes (" LOG_FILENAME ")", &Debugging_UpdateSettings },
   { gui_radio_proc,      NC_X+10,     NC_Y+35,  85,       16,       0,       1,   0,    "No", &Debugging_UpdateSettings },

   /* no. 5 - Show utils */
   { gui_button_proc,     NC_X+110,    NC_Y+5,   125,      20,       0,       0,   0,    "Show memory-dump", &MemDump_Init },
   { gui_button_proc,     NC_X+110,    NC_Y+30,  125,      20,       0,       0,   0,    "Show palette-viewer", &PalView_Init },
   { gui_button_proc,     NC_X+110,    NC_Y+55,  125,      20,       0,       0,   0,    "Show performance-monitor", &PerfMon_Init },

   /* OK button */
   { gui_button_proc,     NC_X+18,     NC_Y+55,  70,       20,       D_EXIT,  0,   0,    "OK", NULL },
   { NULL }
};

int Emu_Options(WINDOW *window, GADGET *d)
{
   const char *str;
   int x, y;

   if (options_window)
   {
      GUI_SwitchFocus(options_window);
      return D_O_K;
   }

   /* see what the frameskip is */
   if (frameskip == 0)
   {
      gui_options_dialog[3].flags |= D_SELECTED;
      gui_options_dialog[4].flags &= ~D_SELECTED;
   } else {
      gui_options_dialog[3].flags &= ~D_SELECTED;
      gui_options_dialog[4].flags |= D_SELECTED;
      gui_options_dialog[5].flags &= ~D_DISABLED;
      frameskip_value[0] = frameskip + '0';
      frameskip_value[1] = NULL;
   }

   /* check for vsync */
   if (use_vsync)
   {
      gui_options_dialog[7].flags |= D_SELECTED;
      gui_options_dialog[8].flags &= ~D_SELECTED;
   } else {
      gui_options_dialog[7].flags &= ~D_SELECTED;
      gui_options_dialog[8].flags |= D_SELECTED;
   }

   /* clear the sample rate */
   gui_options_dialog[10].flags &= ~D_SELECTED;
   gui_options_dialog[11].flags &= ~D_SELECTED;
   gui_options_dialog[12].flags &= ~D_SELECTED;

   sample_rate = get_config_int("Audio_settings", "sample_rate", 22050);

   /* use a bit of heuristics :) */
   if (sample_rate < 15000)
      gui_options_dialog[10].flags |= D_SELECTED;
   else if (sample_rate < 30000)
      gui_options_dialog[11].flags |= D_SELECTED;
   else
      gui_options_dialog[12].flags |= D_SELECTED;

   /* check for scanlines */
   if (use_scanlines)
   {
      gui_options_dialog[38].flags |= D_SELECTED;
      gui_options_dialog[39].flags &= ~D_SELECTED;
   } else {
      gui_options_dialog[38].flags &= ~D_SELECTED;
      gui_options_dialog[39].flags |= D_SELECTED;
   }

   /* figure out what keyboard we've got */

   str = get_config_string(NULL, "keyboard", "US");
   y = 14; /* US as default */
   if (stricmp(str, "UK")==0) y = 15;
   if (stricmp(str, "BE")==0) y = 16;
   if (stricmp(str, "DK")==0) y = 17;
   if (stricmp(str, "DVORAK")==0) y = 18;
   if (stricmp(str, "FI")==0) y = 19;
   if (stricmp(str, "FR")==0) y = 20;
   if (stricmp(str, "DE")==0) y = 21;
   if (stricmp(str, "IT")==0) y = 22;
   if (stricmp(str, "NO")==0) y = 23;
   if (stricmp(str, "PT")==0) y = 24;
   if (stricmp(str, "ES")==0) y = 25;
   if (stricmp(str, "SE")==0) y = 26;

   for (x=14;x<=26;x++)
   {
      if (x == y) gui_options_dialog[x].flags |= D_SELECTED;
      else gui_options_dialog[x].flags &= ~D_SELECTED;
   }

   /* create the Audio/video window */
   GUI_PrintLog(FALSE, "Creating audio/video options window.");
   
   x = get_config_int("Options_window", "x_position", 120);
   y = get_config_int("Options_window", "y_position", 110);
   options_window = GUI_NewWindow(x, y, gui_options_dialog, &Options_Shutdown);
   if (!options_window)
      return D_O_K;

   return D_O_K;
}

int Emu_Debugging(WINDOW *window, GADGET *d)
{
   int x, y;

   if (debug_window)
   {
      GUI_SwitchFocus(debug_window);
      return D_O_K;
   }

   if (log_file)
   {
      gui_debugging_dialog[3].flags |= D_SELECTED;
      gui_debugging_dialog[4].flags &= ~D_SELECTED;
   } else {
      gui_debugging_dialog[4].flags |= D_SELECTED;
      gui_debugging_dialog[3].flags &= ~D_SELECTED;
   }

   /* create the debugging window */
   GUI_PrintLog(FALSE, "Creating debugging options window.");

   x = get_config_int("Debugging_window", "x_position", 120);
   y = get_config_int("Debugging_window", "y_position", 110);
   debug_window = GUI_NewWindow(x, y, gui_debugging_dialog, &Debugging_Shutdown);
   if (!debug_window)
      return D_O_K;

   return D_O_K;
}

void Options_Shutdown(WINDOW *window)
{
   GUI_PrintLog(FALSE, "Saving options.");

   if (window)
   {
      set_config_int("Options_window", "x_position", window->x);
      set_config_int("Options_window", "y_position", window->y);
   }
   options_window = NULL;
}

void Debugging_Shutdown(WINDOW *window)
{
   GUI_PrintLog(FALSE, "Saving debugging settings.");

   if (log_file)
      set_config_string("Debugging", "write_log", "yes");
   else
      set_config_string("Debugging", "write_log", "no");

   if (window)
   {
      set_config_int("Debugging_window", "x_position", window->x);
      set_config_int("Debugging_window", "y_position", window->y);
   }
   debug_window = NULL;
}

int Options_UpdateSettings(WINDOW *window, GADGET *d)
{
   if (gui_options_dialog[3].flags & D_SELECTED)
   {
      gui_options_dialog[5].flags |= D_DISABLED;
      frameskip = 0;
   } else {
      gui_options_dialog[5].flags &= ~D_DISABLED;
      frameskip = atoi(frameskip_value);
      if (frameskip == 0) frameskip = 1;
   }
   gui_options_dialog[5].flags |= D_DIRTY;

   if (gui_options_dialog[7].flags & D_SELECTED)
   {
      use_vsync = TRUE;
      if (emu_window) emu_window->flags |= W_VSYNC;
   } else {
      use_vsync = FALSE;
      if (emu_window) emu_window->flags &= ~W_VSYNC;
   }

   if (gui_options_dialog[38].flags & D_SELECTED)
   {
      use_scanlines = TRUE;
   } else {
      use_scanlines = FALSE;
   }

   if (gui_options_dialog[10].flags & D_SELECTED)
      set_config_int("Audio_settings", "sample_rate", 11025);
   if (gui_options_dialog[11].flags & D_SELECTED)
      set_config_int("Audio_settings", "sample_rate", 22050);
   if (gui_options_dialog[12].flags & D_SELECTED)
      set_config_int("Audio_settings", "sample_rate", 44100);

   if (gui_options_dialog[14].flags & D_SELECTED)
      set_config_string(NULL, "keyboard", "US");
   if (gui_options_dialog[15].flags & D_SELECTED)
      set_config_string(NULL, "keyboard", "UK");
   if (gui_options_dialog[16].flags & D_SELECTED)
      set_config_string(NULL, "keyboard", "BE");
   if (gui_options_dialog[17].flags & D_SELECTED)
      set_config_string(NULL, "keyboard", "DK");
   if (gui_options_dialog[18].flags & D_SELECTED)
      set_config_string(NULL, "keyboard", "DVORAK");
   if (gui_options_dialog[19].flags & D_SELECTED)
      set_config_string(NULL, "keyboard", "FI");
   if (gui_options_dialog[20].flags & D_SELECTED)
      set_config_string(NULL, "keyboard", "FR");
   if (gui_options_dialog[21].flags & D_SELECTED)
      set_config_string(NULL, "keyboard", "DE");
   if (gui_options_dialog[22].flags & D_SELECTED)
      set_config_string(NULL, "keyboard", "IT");
   if (gui_options_dialog[23].flags & D_SELECTED)
      set_config_string(NULL, "keyboard", "NO");
   if (gui_options_dialog[24].flags & D_SELECTED)
      set_config_string(NULL, "keyboard", "PT");
   if (gui_options_dialog[25].flags & D_SELECTED)
      set_config_string(NULL, "keyboard", "ES");
   if (gui_options_dialog[26].flags & D_SELECTED)
      set_config_string(NULL, "keyboard", "SE");

   /* reset the keyboard handler */
   remove_keyboard();
   install_keyboard();

   return D_O_K;
}

int Debugging_UpdateSettings(WINDOW *window, GADGET *d)
{
   if (gui_debugging_dialog[4].flags & D_SELECTED)
   {
      if (log_file)
      {
         GUI_PrintLog(FALSE, "Closing log file.");
         fclose(log_file);
         log_file = NULL;
      }
   } else {
      if (!log_file)
      {
         log_file = fopen(LOG_FILENAME, "w");
         GUI_PrintLog(FALSE, "Re-opening log file.");
      }
   }
   return D_O_K;
}
